import aliLink,mqttd,rpi
import time,json
import BH1750

# 三元素（iot后台获取）
ProductKey = '***'
DeviceName = 'raspberrypi4-******'
DeviceSecret = "assef***"
# topic (iot后台获取)
POST = '/sys/***/raspberrypi4-***/thing/event/property/post'  # 上报消息到云
POST_REPLY = '/sys/***/raspberrypi4-***/thing/event/property/post_reply'
SET = '/sys/***/raspberrypi4-***/thing/service/property/set'  # 订阅云端指令


# 消息回调（云端下发消息的回调函数）
def on_message(client, userdata, msg):
    try:
        Msg = json.loads(msg.payload)
        switch = Msg['params']['PowerLed']
        rpi.powerLed(switch)
    except Exception as e:
        print(e)
    print(msg.payload)  # 开关值

#连接回调（与阿里云建立链接后的回调函数）
def on_connect(client, userdata, flags, rc):
    pass

# 链接信息
Server,ClientId,userNmae,Password = aliLink.linkiot(DeviceName,ProductKey,DeviceSecret)

# mqtt链接
mqtt = mqttd.MQTT(Server,ClientId,userNmae,Password)
mqtt.subscribe(SET) # 订阅服务器下发消息topic
mqtt.begin(on_message,on_connect)


# 信息获取上报，每10秒钟上报一次系统参数
while True:
    time.sleep(1)

    GeoLocation = "_"
    LightLux = BH1750.getIlluminance_1()#读取光照强度函数
    CurrentHumidity, CurrentTemperature = Adafruit_DHT.read_retry(11, 4)
    # 构建与云端模型一致的消息结构
    updateMsn = {
        'GeoLocation':GeoLocation,
        'CurrentHumidity':CurrentHumidity,
        'CurrentTemperature':CurrentTemperature,
        'LightLux':LightLux

    }
    JsonUpdataMsn = aliLink.Alink(updateMsn)
    print(JsonUpdataMsn)

    mqtt.push(POST,JsonUpdataMsn) # 定时向阿里云IOT推送我们构建好的Alink协议数据
